package application

import (
	"net/http"
	"vegan-barcode/internal/models"

	"github.com/gin-gonic/gin"
)

func (a *Application) GetClaimsHandler(c *gin.Context) {
	system := c.Query("system")
	barcode := c.Query("barcode")

	productClaims, err := a.GetClaims(system, barcode)
	if err != nil {
		c.JSON(http.StatusInternalServerError, nil)
		return
	}
	c.JSON(http.StatusOK, productClaims)
}

func (a *Application) PostClaimHandler(c *gin.Context) {
	system := c.Query("system")
	barcode := c.Query("barcode")

	var requestBody models.UserClaimForm
	c.BindJSON(&requestBody)

	a.CreateClaim(system, barcode, requestBody)
}
